win = {
	Create = function(self, winer, itemLink, owner, rolled)
		local frame = CreateFrame("Frame", "LH_Win", UIParent, "BasicFrameTemplate")
		frame.winer = winer
		frame.itemLink = itemLink
		frame.owner = owner
		frame.rolled = rolled
		frame.timeElapsed = 0
		frame.trackTime = false
		frame.player = GetUnitName("player", false);
		frame.tradeShown = false;
		frame:SetPoint("CENTER", 0, 0)
		frame:SetWidth(250)
		frame:SetHeight(80)
		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:SetToplevel(true)
		frame:SetUserPlaced(true)
		frame:SetClampedToScreen(true)
		frame:SetClampRectInsets(0, 0, 0, 0)

		frame:SetScript("OnMouseDown",
		function(self, button)
			self:StartMoving()
			self.trackTime = true
		end
		)
		frame:SetScript("OnMouseUp",
		function(self, button)
			self:StopMovingOrSizing()
			self.trackTime = false
			if self.timeElapsed < 0.5 then
				if self.winer ~= nil then
					self:Trade()
				end
			end
			self.timeElapsed = 0
		end
		)
		frame:RegisterEvent("TRADE_SHOW")
		frame:RegisterEvent("TRADE_CLOSED");
		-- frame:RegisterEvent("TRADE_PLAYER_ITEM_CHANGED");

		frame:SetScript("OnEvent",
		function(self, event)
			if event == "TRADE_SHOW" then
				self.tradeShown = true
				self:Trade()
			elseif event == "TRADE_CLOSED" then
				self.tradeShown = false
			end
		end
		)
		frame.SetShown = function(self, shown)
			frame.tradeShown = shown
		end

		frame.Trade = function()

			if frame.winer ~= nil and frame.player ~= nil and frame.owner ~= nil and frame.rolled ~= nil and frame:IsShown() then

				if frame.winer ~= frame.player then
					if (not frame.tradeShown) then
						InitiateTrade(frame.winer)
					end
					if TradeFrameRecipientNameText:GetText() == frame.winer then
						local link
						local found = false
						for container = 0, NUM_BAG_SLOTS do
							for slot = 0, GetContainerNumSlots(container) do
								link = GetContainerItemLink(container, slot)
								if link == frame.itemLink then
									if frame.tradeShown then
										PickupContainerItem(container, slot)
										ClickTradeButton(TradeFrame_GetAvailableSlot())
									end
									return
								end
							end
						end
					end
				else
					if (not frame.tradeShown) then
						InitiateTrade(frame.owner)
					end
				end
			end
		end

		frame:SetScript("OnUpdate",
		function(self, elapsed, ...)
			if self.trackTime then
				self.timeElapsed = self.timeElapsed + elapsed
			end
		end
		)


		local title = frame:CreateFontString("LH_Win_Title", "ARTWORK")
		title:SetPoint("TOP", frame, "TOP", 0, 0)
		title:SetWidth(240)
		title:SetHeight(22)
		title:SetFont("Fonts\\FRIZQT__.TTF", 15, nil)
		title:SetText("You Won")

		local message = frame:CreateFontString("LH_Win_Message", "ARTWORK")
		message:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -3, 3)
		message:SetWidth(200)
		message:SetHeight(60)
		message:SetFont("Fonts\\FRIZQT__.TTF", 12, nil)
		message:SetText(message)

		local texture = frame:CreateTexture("LH_Win_Texture")
		texture:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 3, 5)
		texture:SetWidth(45)
		texture:SetHeight(45)
		texture:SetTexture(texture)

		frame.title = title
		frame.message = message
		frame.texture = texture

		frame.SetInfo = function(self, winer, itemLink, owner, rolled)

			self.winer = winer
			self.itemLink = itemLink
			self.owner = owner
			self.rolled = rolled

			if self.winer == self.player and self.owner ~= nil and self.rolled ~= nil then
				-- ("You Won", itemLink, owner .. " with " .. rolled)

				self.title:SetFont("Fonts\\FRIZQT__.TTF", 15, nil)
				self.title:SetText("You Won")

				self.message:SetFont("Fonts\\FRIZQT__.TTF", 12, nil)
				self.message:SetText(self.itemLink .. "\nFrom\n" .. self.owner .. " with " .. self.rolled)

			end
			if self.owner == self.player and self.winer ~= nil and self.rolled ~= nil then
				-- (winer .. " Won", itemLink, "you with " .. rolled)
				self.title:SetFont("Fonts\\FRIZQT__.TTF", 15, nil)
				self.title:SetText(self.winer .. " Won")

				self.message:SetFont("Fonts\\FRIZQT__.TTF", 12, nil)
				self.message:SetText(self.itemLink .. "\nFrom\n" .. "you with " .. self.rolled)


			end
			if self.winer == nil and self.rolled == nil and self.owner == self.player then
				self.title:SetFont("Fonts\\FRIZQT__.TTF", 15, nil)
				self.title:SetText("Nobody Rolled For")

				self.message:SetFont("Fonts\\FRIZQT__.TTF", 12, nil)
				self.message:SetText(self.itemLink .. "\nFrom\n" .. "you")
			end

			self.texture:SetTexture(GetItemIcon(self.itemLink))

			self:Show()
		end

		frame:SetInfo(winer, itemLink, owner, rolled);
		return frame;
	end
}
